﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text

Imports System.ComponentModel
Imports System.Collections.ObjectModel
Imports System.Linq.Expressions
Imports IdeaBlade.EntityModel
Imports System.Collections
Imports IdeaBlade.Linq
Imports System.Reflection


Public Class MainDemo
  Private _resultsReporter As ResultsReporter

  Public Sub New(ByVal callbackMethod As ResultsReporter)
    Utility.InitializeDemo(_nameDemo, callbackMethod, _resultsReporter, _localOutput)
  End Sub

  Public Sub BasicQuerySyntaxQuery()
    _localOutput.Append([String].Format("[{0}] Started..." & vbLf, _nameBasicQuerySyntaxQuery))

    Utility.ResetEntityManager(_em1)
    _em1.ConnectAsync(Sub(args)
                        If args.CompletedSuccessfully Then
                          Dim customersQuery = _em1.Customers.Where(Function(c) c.ContactTitle = "Sales Representative").OrderBy(Function(c) c.CompanyName)
                          _em1.ExecuteQueryAsync(Of Customer)(customersQuery, AddressOf GotCustomers, Nothing)
                        End If
                      End Sub, Nothing)
    
  End Sub

  Private Sub GotCustomers(ByVal args As EntityQueryOperation(Of Customer))
    _localOutput.Append(String.Format("[{0}] Retrieved {1} customers" & vbLf, _nameBasicQuerySyntaxQuery, args.Results.Count()))
    Utility.FlushOutputBuffer(_localOutput, _resultsReporter)
  End Sub

#Region "Private Fields"

  Const _nameDemo As String = "MainDemo (MDM)"
  Const _nameBasicQuerySyntaxQuery As String = "MDM:BasicQuerySyntaxQuery"
  Const _nameQueryCacheDataSynchronously As String = "MDM:QueryCacheDataSynchronously"
  Const _nameGetFirstCustomer As String = "MDM:GetFirstCustomer"

  Private _em1 As New NorthwindIBModelManager(shouldConnect:=False)
  Private _localOutput As StringBuilder

#End Region

End Class